Package com.google.android.exoplayer2.offline

## Interface Downloader

- All Known Implementing Classes:
    `DashDownloader`, `HlsDownloader`, `ProgressiveDownloader`, `SegmentDownloader`, `SsDownloader`

      public interface Downloader

  Downloads and removes a piece of content.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static interface` | `Downloader.ProgressListener` | Receives progress updates during download operations.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `cancel()` | Permanently cancels the downloading by this downloader.
    `void` | `download​(Downloader.ProgressListener progressListener)` | Downloads the content.
    `void` | `remove()` | Removes the content.

- - ### Method Detail

    - #### download

          void download​(@Nullable
                        Downloader.ProgressListener progressListener)
                 throws IOException,
                        InterruptedException

      Downloads the content.

      If downloading fails, this method can be called again to resume the download. It cannot be called again after the download has been `canceled`.

      If downloading is canceled whilst this method is executing, then it is expected that it will return reasonably quickly. However, there are no guarantees about how the method will return, meaning that it can return without throwing, or by throwing any of its documented exceptions. The caller must use its own knowledge about whether downloading has been canceled to determine whether this is why the method has returned, rather than relying on the method returning in a particular way.

      Parameters:
        `progressListener` - A listener to receive progress updates, or `null`.
      Throws:
        `IOException` - If the download failed to complete successfully.
        `InterruptedException` - If the download was interrupted.
        `CancellationException` - If the download was canceled.

    - #### cancel

          void cancel()

      Permanently cancels the downloading by this downloader. The caller should also interrupt the downloading thread immediately after calling this method.

      Once canceled, `download(com.google.android.exoplayer2.offline.Downloader.ProgressListener)` cannot be called again.

    - #### remove

          void remove()

      Removes the content.